<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/adler-1.0.2/src/algo.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>algo.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../adler/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../adler/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../adler/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
</pre><pre class="rust"><code><span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::Adler32</span>;
<span class="kw">use</span> <span class="ident">std::ops</span>::{<span class="ident">AddAssign</span>, <span class="ident">MulAssign</span>, <span class="ident">RemAssign</span>};

<span class="kw">impl</span> <span class="ident">Adler32</span> {
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">compute</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">bytes</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>]) {
        <span class="comment">// The basic algorithm is, for every byte:</span>
        <span class="comment">//   a = (a + byte) % MOD</span>
        <span class="comment">//   b = (b + a) % MOD</span>
        <span class="comment">// where MOD = 65521.</span>
        <span class="comment">//</span>
        <span class="comment">// For efficiency, we can defer the `% MOD` operations as long as neither a nor b overflows:</span>
        <span class="comment">// - Between calls to `write`, we ensure that a and b are always in range 0..MOD.</span>
        <span class="comment">// - We use 32-bit arithmetic in this function.</span>
        <span class="comment">// - Therefore, a and b must not increase by more than 2^32-MOD without performing a `% MOD`</span>
        <span class="comment">//   operation.</span>
        <span class="comment">//</span>
        <span class="comment">// According to Wikipedia, b is calculated as follows for non-incremental checksumming:</span>
        <span class="comment">//   b = n×D1 + (n−1)×D2 + (n−2)×D3 + ... + Dn + n*1 (mod 65521)</span>
        <span class="comment">// Where n is the number of bytes and Di is the i-th Byte. We need to change this to account</span>
        <span class="comment">// for the previous values of a and b, as well as treat every input Byte as being 255:</span>
        <span class="comment">//   b_inc = n×255 + (n-1)×255 + ... + 255 + n*65520</span>
        <span class="comment">// Or in other words:</span>
        <span class="comment">//   b_inc = n*65520 + n(n+1)/2*255</span>
        <span class="comment">// The max chunk size is thus the largest value of n so that b_inc &lt;= 2^32-65521.</span>
        <span class="comment">//   2^32-65521 = n*65520 + n(n+1)/2*255</span>
        <span class="comment">// Plugging this into an equation solver since I can&#39;t math gives n = 5552.18..., so 5552.</span>
        <span class="comment">//</span>
        <span class="comment">// On top of the optimization outlined above, the algorithm can also be parallelized with a</span>
        <span class="comment">// bit more work:</span>
        <span class="comment">//</span>
        <span class="comment">// Note that b is a linear combination of a vector of input bytes (D1, ..., Dn).</span>
        <span class="comment">//</span>
        <span class="comment">// If we fix some value k&lt;N and rewrite indices 1, ..., N as</span>
        <span class="comment">//</span>
        <span class="comment">//   1_1, 1_2, ..., 1_k, 2_1, ..., 2_k, ..., (N/k)_k,</span>
        <span class="comment">//</span>
        <span class="comment">// then we can express a and b in terms of sums of smaller sequences kb and ka:</span>
        <span class="comment">//</span>
        <span class="comment">//   ka(j) := D1_j + D2_j + ... + D(N/k)_j where j &lt;= k</span>
        <span class="comment">//   kb(j) := (N/k)*D1_j + (N/k-1)*D2_j + ... + D(N/k)_j where j &lt;= k</span>
        <span class="comment">//</span>
        <span class="comment">//  a = ka(1) + ka(2) + ... + ka(k) + 1</span>
        <span class="comment">//  b = k*(kb(1) + kb(2) + ... + kb(k)) - 1*ka(2) - ...  - (k-1)*ka(k) + N</span>
        <span class="comment">//</span>
        <span class="comment">// We use this insight to unroll the main loop and process k=4 bytes at a time.</span>
        <span class="comment">// The resulting code is highly amenable to SIMD acceleration, although the immediate speedups</span>
        <span class="comment">// stem from increased pipeline parallelism rather than auto-vectorization.</span>
        <span class="comment">//</span>
        <span class="comment">// This technique is described in-depth (here:)[https://software.intel.com/content/www/us/\</span>
        <span class="comment">// en/develop/articles/fast-computation-of-fletcher-checksums.html]</span>

        <span class="kw">const</span> <span class="ident">MOD</span>: <span class="ident">u32</span> <span class="op">=</span> <span class="number">65521</span>;
        <span class="kw">const</span> <span class="ident">CHUNK_SIZE</span>: <span class="ident">usize</span> <span class="op">=</span> <span class="number">5552</span> <span class="op">*</span> <span class="number">4</span>;

        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">a</span> <span class="op">=</span> <span class="ident">u32::from</span>(<span class="self">self</span>.<span class="ident">a</span>);
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">b</span> <span class="op">=</span> <span class="ident">u32::from</span>(<span class="self">self</span>.<span class="ident">b</span>);
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">a_vec</span> <span class="op">=</span> <span class="ident">U32X4</span>([<span class="number">0</span>; <span class="number">4</span>]);
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">b_vec</span> <span class="op">=</span> <span class="ident">a_vec</span>;

        <span class="kw">let</span> (<span class="ident">bytes</span>, <span class="ident">remainder</span>) <span class="op">=</span> <span class="ident">bytes</span>.<span class="ident">split_at</span>(<span class="ident">bytes</span>.<span class="ident">len</span>() <span class="op">-</span> <span class="ident">bytes</span>.<span class="ident">len</span>() <span class="op">%</span> <span class="number">4</span>);

        <span class="comment">// iterate over 4 bytes at a time</span>
        <span class="kw">let</span> <span class="ident">chunk_iter</span> <span class="op">=</span> <span class="ident">bytes</span>.<span class="ident">chunks_exact</span>(<span class="ident">CHUNK_SIZE</span>);
        <span class="kw">let</span> <span class="ident">remainder_chunk</span> <span class="op">=</span> <span class="ident">chunk_iter</span>.<span class="ident">remainder</span>();
        <span class="kw">for</span> <span class="ident">chunk</span> <span class="kw">in</span> <span class="ident">chunk_iter</span> {
            <span class="kw">for</span> <span class="ident">byte_vec</span> <span class="kw">in</span> <span class="ident">chunk</span>.<span class="ident">chunks_exact</span>(<span class="number">4</span>) {
                <span class="kw">let</span> <span class="ident">val</span> <span class="op">=</span> <span class="ident">U32X4::from</span>(<span class="ident">byte_vec</span>);
                <span class="ident">a_vec</span> <span class="op">+</span><span class="op">=</span> <span class="ident">val</span>;
                <span class="ident">b_vec</span> <span class="op">+</span><span class="op">=</span> <span class="ident">a_vec</span>;
            }
            <span class="ident">b</span> <span class="op">+</span><span class="op">=</span> <span class="ident">CHUNK_SIZE</span> <span class="kw">as</span> <span class="ident">u32</span> <span class="op">*</span> <span class="ident">a</span>;
            <span class="ident">a_vec</span> <span class="op">%</span><span class="op">=</span> <span class="ident">MOD</span>;
            <span class="ident">b_vec</span> <span class="op">%</span><span class="op">=</span> <span class="ident">MOD</span>;
            <span class="ident">b</span> <span class="op">%</span><span class="op">=</span> <span class="ident">MOD</span>;
        }
        <span class="comment">// special-case the final chunk because it may be shorter than the rest</span>
        <span class="kw">for</span> <span class="ident">byte_vec</span> <span class="kw">in</span> <span class="ident">remainder_chunk</span>.<span class="ident">chunks_exact</span>(<span class="number">4</span>) {
            <span class="kw">let</span> <span class="ident">val</span> <span class="op">=</span> <span class="ident">U32X4::from</span>(<span class="ident">byte_vec</span>);
            <span class="ident">a_vec</span> <span class="op">+</span><span class="op">=</span> <span class="ident">val</span>;
            <span class="ident">b_vec</span> <span class="op">+</span><span class="op">=</span> <span class="ident">a_vec</span>;
        }
        <span class="ident">b</span> <span class="op">+</span><span class="op">=</span> <span class="ident">remainder_chunk</span>.<span class="ident">len</span>() <span class="kw">as</span> <span class="ident">u32</span> <span class="op">*</span> <span class="ident">a</span>;
        <span class="ident">a_vec</span> <span class="op">%</span><span class="op">=</span> <span class="ident">MOD</span>;
        <span class="ident">b_vec</span> <span class="op">%</span><span class="op">=</span> <span class="ident">MOD</span>;
        <span class="ident">b</span> <span class="op">%</span><span class="op">=</span> <span class="ident">MOD</span>;

        <span class="comment">// combine the sub-sum results into the main sum</span>
        <span class="ident">b_vec</span> <span class="kw-2">*</span><span class="op">=</span> <span class="number">4</span>;
        <span class="ident">b_vec</span>.<span class="number">0</span>[<span class="number">1</span>] <span class="op">+</span><span class="op">=</span> <span class="ident">MOD</span> <span class="op">-</span> <span class="ident">a_vec</span>.<span class="number">0</span>[<span class="number">1</span>];
        <span class="ident">b_vec</span>.<span class="number">0</span>[<span class="number">2</span>] <span class="op">+</span><span class="op">=</span> (<span class="ident">MOD</span> <span class="op">-</span> <span class="ident">a_vec</span>.<span class="number">0</span>[<span class="number">2</span>]) <span class="op">*</span> <span class="number">2</span>;
        <span class="ident">b_vec</span>.<span class="number">0</span>[<span class="number">3</span>] <span class="op">+</span><span class="op">=</span> (<span class="ident">MOD</span> <span class="op">-</span> <span class="ident">a_vec</span>.<span class="number">0</span>[<span class="number">3</span>]) <span class="op">*</span> <span class="number">3</span>;
        <span class="kw">for</span> <span class="kw-2">&amp;</span><span class="ident">av</span> <span class="kw">in</span> <span class="ident">a_vec</span>.<span class="number">0</span>.<span class="ident">iter</span>() {
            <span class="ident">a</span> <span class="op">+</span><span class="op">=</span> <span class="ident">av</span>;
        }
        <span class="kw">for</span> <span class="kw-2">&amp;</span><span class="ident">bv</span> <span class="kw">in</span> <span class="ident">b_vec</span>.<span class="number">0</span>.<span class="ident">iter</span>() {
            <span class="ident">b</span> <span class="op">+</span><span class="op">=</span> <span class="ident">bv</span>;
        }

        <span class="comment">// iterate over the remaining few bytes in serial</span>
        <span class="kw">for</span> <span class="kw-2">&amp;</span><span class="ident">byte</span> <span class="kw">in</span> <span class="ident">remainder</span>.<span class="ident">iter</span>() {
            <span class="ident">a</span> <span class="op">+</span><span class="op">=</span> <span class="ident">u32::from</span>(<span class="ident">byte</span>);
            <span class="ident">b</span> <span class="op">+</span><span class="op">=</span> <span class="ident">a</span>;
        }

        <span class="self">self</span>.<span class="ident">a</span> <span class="op">=</span> (<span class="ident">a</span> <span class="op">%</span> <span class="ident">MOD</span>) <span class="kw">as</span> <span class="ident">u16</span>;
        <span class="self">self</span>.<span class="ident">b</span> <span class="op">=</span> (<span class="ident">b</span> <span class="op">%</span> <span class="ident">MOD</span>) <span class="kw">as</span> <span class="ident">u16</span>;
    }
}

<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Copy</span>, <span class="ident">Clone</span>)]</span>
<span class="kw">struct</span> <span class="ident">U32X4</span>([<span class="ident">u32</span>; <span class="number">4</span>]);

<span class="kw">impl</span> <span class="ident">U32X4</span> {
    <span class="kw">fn</span> <span class="ident">from</span>(<span class="ident">bytes</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>]) -&gt; <span class="self">Self</span> {
        <span class="ident">U32X4</span>([
            <span class="ident">u32::from</span>(<span class="ident">bytes</span>[<span class="number">0</span>]),
            <span class="ident">u32::from</span>(<span class="ident">bytes</span>[<span class="number">1</span>]),
            <span class="ident">u32::from</span>(<span class="ident">bytes</span>[<span class="number">2</span>]),
            <span class="ident">u32::from</span>(<span class="ident">bytes</span>[<span class="number">3</span>]),
        ])
    }
}

<span class="kw">impl</span> <span class="ident">AddAssign</span><span class="op">&lt;</span><span class="self">Self</span><span class="op">&gt;</span> <span class="kw">for</span> <span class="ident">U32X4</span> {
    <span class="kw">fn</span> <span class="ident">add_assign</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">other</span>: <span class="self">Self</span>) {
        <span class="kw">for</span> (<span class="ident">s</span>, <span class="ident">o</span>) <span class="kw">in</span> <span class="self">self</span>.<span class="number">0</span>.<span class="ident">iter_mut</span>().<span class="ident">zip</span>(<span class="ident">other</span>.<span class="number">0</span>.<span class="ident">iter</span>()) {
            <span class="kw-2">*</span><span class="ident">s</span> <span class="op">+</span><span class="op">=</span> <span class="ident">o</span>;
        }
    }
}

<span class="kw">impl</span> <span class="ident">RemAssign</span><span class="op">&lt;</span><span class="ident">u32</span><span class="op">&gt;</span> <span class="kw">for</span> <span class="ident">U32X4</span> {
    <span class="kw">fn</span> <span class="ident">rem_assign</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">quotient</span>: <span class="ident">u32</span>) {
        <span class="kw">for</span> <span class="ident">s</span> <span class="kw">in</span> <span class="self">self</span>.<span class="number">0</span>.<span class="ident">iter_mut</span>() {
            <span class="kw-2">*</span><span class="ident">s</span> <span class="op">%</span><span class="op">=</span> <span class="ident">quotient</span>;
        }
    }
}

<span class="kw">impl</span> <span class="ident">MulAssign</span><span class="op">&lt;</span><span class="ident">u32</span><span class="op">&gt;</span> <span class="kw">for</span> <span class="ident">U32X4</span> {
    <span class="kw">fn</span> <span class="ident">mul_assign</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">rhs</span>: <span class="ident">u32</span>) {
        <span class="kw">for</span> <span class="ident">s</span> <span class="kw">in</span> <span class="self">self</span>.<span class="number">0</span>.<span class="ident">iter_mut</span>() {
            <span class="kw-2">*</span><span class="ident">s</span> <span class="kw-2">*</span><span class="op">=</span> <span class="ident">rhs</span>;
        }
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="adler" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>